HDU--4046--Panda【线段树】

链接:http://acm.hdu.edu.cn/showproblem.php?pid=4046

题意:题目先来了一大段情书,看的我莫名其妙,然后来了一段极像《那些年》歌词翻译的正文,然后才是真正的题目。给你一个字符串,最长50000,只有两种字母,w和b。然后m个操作,操作有两种,第一种是查询l,r区间中有几个字符串是”wbw“形式,第二种操作是把字符串下标k的字符变成输入的字符c。

一眼就能看出是线段树,但是怎么做?我觉得线段树写起来就那样,偶尔需要一些小技巧,多加些节点信息,或者和离散化结合起来。但是线段树最难的地方我觉得还不是这些,而是节点存储什么信息,明白了这个才能着手敲线段树,并且其他步骤就和裸线段树差不多了。我参考着这个博客的题来做线段树:http://blog.csdn.net/shiqi_614/article/details/8228102,有一些题目是基础的,都没问题,我不会做的要么就是英文没读懂,要么就是不知道节点存储什么信息,所以对于我来说,节点存什么,是线段树中最难的点。

这道题也一样,我想了很久,今天下午去踢球的路上想到一种方式:如果是w就用3代替,b就用5代替,再乘它所在的位数,比如”wbw“ 就是 1*3+2*5+3*3 = 22,这样wbw的数字是唯一的,存入线段树中,至于父节点的pushup,如果子节点%22为0再加入到父节点的值中,最后搜到的区间值除以22就是wbw的个数,wbw是三个字母,所以只有两个字母时肯定是不行的,r-l<2肯定也不行。查询的时候把左区间+2,再查询。

更新的时候需要考虑三种情况,当前k位置是第一个字母、第二个字母、第三个字母的情况。

更新位置逗比的写成了k,调试了半天没出样例。。。加了一堆输出中间量,终于发现写逗了。。。改之AC

#include<cstring>
#include<string>
#include<fstream>
#include<iostream>
#include<iomanip>
#include<cstdio>
#include<cctype>
#include<algorithm>
#include<queue>
#include<map>
#include<set>
#include<vector>
#include<stack>
#include<ctime>
#include<cstdlib>
#include<functional>
#include<cmath>
using namespace std;
#define PI acos(-1.0)
#define MAXN 50100
#define eps 1e-7
#define INF 0x7FFFFFFF
#define seed 131
#define mod 1000000007
#define ll long long
#define ull unsigned ll
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1

int sum[MAXN<<2];
int a[MAXN];
int n;
char s[MAXN];
void pushup(int rt){
    sum[rt] = (sum[rt<<1]%22==0?sum[rt<<1]:0) + (sum[rt<<1|1]%22==0?sum[rt<<1|1]:0);
}
void build(int l,int r,int rt){
    if(l==r){
        sum[rt] = a[l];
//        cout<<rt<<" aaa"<<a[l]<<endl;
        return ;
    }
    int m = (l+r)>>1;
    build(lson);
    build(rson);
    pushup(rt);
}
void update(int k,int c,int l,int r,int rt){
    if(l==r){
        sum[rt] = c;
        return ;
    }
    int m = (l+r)>>1;
    if(k<=m) update(k,c,lson);
    else    update(k,c,rson);
    pushup(rt);
}
int query(int L,int R,int l,int r,int rt){
    if(L<=l&&r<=R){
//        cout<<rt<<" "<<sum[rt]<<endl;
        if(sum[rt]%22)  return 0;
        else    return sum[rt];
    }
    int m = (l+r)>>1;
    ll ret = 0;
    if(L<=m) ret += query(L,R,lson);
    if(R>m)    ret += query(L,R,rson);
    return ret;
}
int main(){
    int t,i,j,aa,b,c,k=1;
    int m;
    char str[5];
    scanf("%d",&t);
    while(t--){
        memset(a,0,sizeof(a));
        memset(sum,0,sizeof(sum));
        scanf("%d%d",&n,&m);
        scanf("%s",s);
        //cout<<s<<endl;
        int l = strlen(s);
        for(i=2;i<l;i++){
            a[i] = (s[i-2]=='w'?3:5)*1+(s[i-1]=='w'?3:5)*2+(s[i]=='w'?3:5)*3;
        }
        build(0,n,1);
//        for(i=0;i<n;i++){
//            cout<<a[i]<<" ";
//        }
//        cout<<endl;
        printf("Case %d:\n",k++);
        while(m--){
//            cout<<s<<endl;
//            for(i=0;i<n;i++){
//                cout<<sum[8]<<" "<<sum[9]<<" "<<sum[5]<<" "<<sum[12]<<" "<<sum[13]<<endl;
//            }
            scanf("%d",&aa);
            if(aa==0){
                scanf("%d%d",&b,&c);
                b += 2;
                if(b>c) puts("0");
                else    printf("%d\n",query(b,c,0,n,1)/22);
            }
            else{
                scanf("%d%s",&b,str);
                if(str[0]==s[b])    continue;
                s[b] = str[0];
                if(b>=2){
                    a[b] = (s[b-2]=='w'?3:5)*1+(s[b-1]=='w'?3:5)*2+(s[b]=='w'?3:5)*3;
                    update(b,a[b],0,n,1);
                }
                if(b>=1&&b<n-1){
                    a[b+1] = (s[b-1]=='w'?3:5)*1+(s[b]=='w'?3:5)*2+(s[b+1]=='w'?3:5)*3;
                    update(b+1,a[b+1],0,n,1);
                }
                if(b<n-2){
                    a[b+2] = (s[b]=='w'?3:5)*1+(s[b+1]=='w'?3:5)*2+(s[b+2]=='w'?3:5)*3;
                    update(b+2,a[b+2],0,n,1);
                }
            }
        }

    }
    return 0;
}

HDU--4046--Panda【线段树】,布布扣,bubuko.com

时间: 2025-01-03 18:08:29

HDU--4046--Panda【线段树】的相关文章

HDU 4046 Panda(线段树)

题目大意:在一串字符串中某个区间查询wbw的数目,更新某个位置的字符 思路:线段树,每个枝结点记录以这个点为中心的字符是不是wbw,所以每次某个位置更新的时候,左右两个位置均要更新 而且查询的时候某个区间的wbw的个数,位于边界的字符的值不能算在内 //561MS 3400K 3373 B #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> using names

HDU ACM 4046 Panda 线段树或者树状数组

分析:该題可以用线段树做,也可以用树状数组做:感觉树状数组容易一些,这里就用树状数组了.这里保存字符数组的下标从1开始,树状数组初始化从3开始,因为只有大于等于3使才可能有符合要求的字串出现,最终计算L到R区间的个数时要用getsum(R)-getsum(L+1),因为可能有符合要求的str[L-1],str[L],str[l+1]也被算进去了,实际上他并不在区间L到R内.更新时要注意三种情况,POS,POS+1,POS+2处的都会受影响. #include<iostream> using n

HdU 4046 Panda 段树

链接:http://acm.hdu.edu.cn/showproblem.php?pid=4046 意甲冠军:到了bw组成的长度为n的字符串(n<=50000).有m次操作(m<=10000),每次操作是询问一段范围内wbw的个数.或者改变一个字符成为w或b. 思路:建一棵线段树,每一个结点记录的是从L到R以每一个i为最左边的字母的总共的wbw的个数,单点更新的时候要更新三个点. 代码: #include <iostream> #include <cstdio> #in

hdu 4046 Panda(树状数组)

1 #include <stdio.h> 2 #include <string.h> 3 #include <algorithm> 4 using namespace std; 5 6 const int N = 50007; 7 8 int tree[N], n; 9 char str[N]; 10 11 int lowbit(int x) 12 { 13 return (x & -x); 14 } 15 16 void update(int pos, int

HDU—4046 Panda (线段树)

题目:http://acm.hdu.edu.cn/showproblem.php?pid=4046 题意:给出一个字符串,统计这个字符串任意区间中"wbw"出现的次数. 规定两种操作,一是查询任意区间"wbw"出现次数:二是修改某一位置的字符. 分析:比较明显的线段树,单点更新,区间查询. 线段树记录的信息是区间中出现"wbw"字符的个数,线段树的叶子节点[i,i]记录字符串str中 str[i-2][i-1][i]是否是"wbw&qu

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

HDU 1828 Picture 线段树+扫描线

题意:给你一些矩形的左上角点的坐标和右下角点的坐标,求周长并 最显而易见的思路就是对于x轴和y轴做两次扫描线,对于负数的坐标进行离散化.每次增加的值是线段变化量的绝对值.具体写法和求面积并的差不多. #include <cstdio> #include <algorithm> #include <cstring> #include <vector> using namespace std; #define lson rt << 1 , l , m

HDU 1542 Atlantis(线段树扫描线)

http://acm.hdu.edu.cn/showproblem.php?pid=1542 Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6788    Accepted Submission(s): 2970 Problem Description There are several ancient Greek

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我

hdu 1542 Atlantis(线段树&amp;扫描线&amp;面积并)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6386    Accepted Submission(s): 2814 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i